freeslot(
	"MT_CERVID_LARGESOUL",
	"S_CERVID_LARGESOUL",
	"MT_CERVID_LARGESOUL_PART",
	"S_CERVID_LARGESOUL_PART",
	"MT_CERVID_LARGESOUL_RING",
	"S_CERVID_LARGESOUL_RING",
	"SPR_CVLS"
)

mobjinfo[MT_CERVID_LARGESOUL] = {
	--$Title Large Soul
	--$Sprite CVLSCLCR
	--$Category Hallways Zone
	--$NotAngled 
	doomednum = 7001,
	spawnstate = S_CERVID_LARGESOUL,
	radius = 256*FRACUNIT,
	height = 256*FRACUNIT,
	spawnhealth = 1000,
	flags = MF_SCENERY|MF_NOGRAVITY
}

states[S_CERVID_LARGESOUL] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_CERVID_LARGESOUL
}

mobjinfo[MT_CERVID_LARGESOUL_PART] = {
	doomednum = -1,
	spawnstate = S_CERVID_LARGESOUL_PART,
	radius = 256*FRACUNIT,
	height = 256*FRACUNIT,
	spawnhealth = 1000,
	flags = MF_SCENERY|MF_NOGRAVITY
}

states[S_CERVID_LARGESOUL_PART] = {
	sprite = SPR_CVLS,
	frame = A|FF_ADD,
	tics = -1,
	nextstate = S_CERVID_LARGESOUL_PART
}

mobjinfo[MT_CERVID_LARGESOUL_RING] = {
	doomednum = -1,
	spawnstate = S_CERVID_LARGESOUL_RING,
	radius = 256*FRACUNIT,
	height = 256*FRACUNIT,
	spawnhealth = 1000,
	flags = MF_SCENERY|MF_NOGRAVITY
}

states[S_CERVID_LARGESOUL_RING] = {
	sprite = SPR_CVLS,
	frame = C|FF_ADD,
	tics = -1,
	nextstate = S_CERVID_LARGESOUL_RING
}

addHook("MobjSpawn", function(m)
	for i=1,8 do
		m["_cervid_largesoulpart"..tostring(i)] = P_SpawnMobjFromMobj(m,0,0,0,MT_CERVID_LARGESOUL_PART)
		m["_cervid_largesoulpart"..tostring(i)]._cervid_largesoulindex = i
		m["_cervid_largesoulpart"..tostring(i)].angle = FixedAngle((90*FRACUNIT) * i)
		m["_cervid_largesoulpart"..tostring(i)].target = m
		P_CreateFloorSpriteSlope(m["_cervid_largesoulpart"..tostring(i)])
	end
	m._cervid_largesoulpart9 = P_SpawnMobjFromMobj(m,0,0,0,MT_CERVID_LARGESOUL_RING)
	m._cervid_largesoulpart9._cervid_largesoulindex = 9
	m._cervid_largesoulpart9.target = m
end,MT_CERVID_LARGESOUL)

addHook("MobjSpawn", function(m)
	m.scale = $1 * 4
	m.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_FULLBRIGHT|RF_NOCOLORMAPS
end,MT_CERVID_LARGESOUL_PART)

addHook("MobjSpawn", function(m)
	m.scale = $1 * 7
	m.renderflags = $|RF_PAPERSPRITE|RF_FULLBRIGHT|RF_NOCOLORMAPS
end,MT_CERVID_LARGESOUL_RING)

-- ring thinker
addHook("MobjThinker",function(mo)
	if mo.target.valid == false or mo.target == nil then
		P_RemoveMobj(mo)
		return
	end
	
	P_SpawnGhostMobj(mo)
	mo.angle = $1 + FixedAngle(2*FRACUNIT)
end,MT_CERVID_LARGESOUL_RING)

-- setup parts here
addHook("MobjThinker",function(mo)
	if mo.target.valid == false or mo.target == nil then
		P_RemoveMobj(mo)
		return
	end
	
	mo.frame = mo._cervid_largesoulindex <= 4 and A|FF_ADD or B|FF_ADD
	
	--local pos_z = mo.target.z + ((mo._cervid_largesoulindex <= 4 and 1 or -1) * mapobjectscale)
	
	local pos_angle = FixedAngle((leveltime * FRACUNIT) + (((90*FRACUNIT) * mo._cervid_largesoulindex)))
	local pos_dist = FixedInt(180*mo.scale)
	local pos_x = mo.target.x + (sin(pos_angle) * pos_dist)
	local pos_y = mo.target.y + (cos(pos_angle) * pos_dist)
	
	P_MoveOrigin(mo,pos_x,pos_y,mo.target.z)
	
	mo.angle = FixedAngle((-90*FRACUNIT) * mo._cervid_largesoulindex) + FixedAngle(-leveltime * FRACUNIT) + ANGLE_45
	--mo.angle = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y) + ANGLE_135
	
	mo.floorspriteslope.xydirection = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y)
	mo.floorspriteslope.zangle = mo._cervid_largesoulindex <= 4 and (ANG1*50) or (ANG1*-50)
	mo.floorspriteslope.o = {x = mo.x, y = mo.y, z = mo.z}
end,MT_CERVID_LARGESOUL_PART)
