local REFLECTPLANE_VER = 1

local MAXHITLAGTICS = 30 -- from base game

local function add_all_hitlag(mo,num,dmg)
	K_AddHitLag(mo,min(num,MAXHITLAGTICS),dmg)
	if num <= MAXHITLAGTICS then return end
	mo.hitlag = $ + (num - MAXHITLAGTICS)
end

local function set_bounce_chances(mo,num,absolute)
	mo.player._lvm_bouncetries = absolute and num or $ + num
end

local function _current_do_bounce(mo,args)
	local chances, normalvel, yeetvel = args[1], args[2], args[3]
	mo.player._lvm_maxbouncetries = chances
	set_bounce_chances(mo,min(chances,mo.player._lvm_bouncetries),true)
	
	local s = FixedDiv(mapobjectscale,FixedDiv(mo.scale,mapobjectscale))
	
	local h = 35
	if mo.player._lvm_bouncetries >= 3 then
		h = 3	
	elseif mo.player._lvm_bouncetries == 2 then
		h = 10
	elseif mo.player._lvm_bouncetries == 1 then
		h = 21
	end
	
	mo.player._lvm_landedfrombounce = 2
	
	if mo.player._lvm_bouncetries == 1 then
		S_StartSoundAtVolume(mo,sfx_gshc7,192);
	end
	if mo.player._lvm_bouncetries <= 0 then
		P_DamageMobj(mo,nil,nil,1,DMG_STUMBLE);
	end
	
	mo.player.fastfall = 0
	mo.player.pflags = $|PF_NOFASTFALL
	
	if mo.player._lvm_bouncetries <= 0 then
		S_StartSound(mo,sfx_kc40)
		S_StartSound(mo,sfx_s3k45)
		S_StartSound(mo,sfx_cdfm34)
		S_StartSound(mo,sfx_mspogo)
	else
		S_StartSound(mo,sfx_kc40)
		S_StartSound(mo,sfx_s3k45)
	end
	
	add_all_hitlag(mo,h,mo.player._lvm_bouncetries <= 1)
	
	local v = mo.player._lvm_bouncetries <= 0 and yeetvel or normalvel
	
	if mo.standingslope then
		local n = mo.standingslope.normal
		mo.momx = $ + FixedMul(v*n.x,mapobjectscale)
		mo.momy = $ + FixedMul(v*n.y,mapobjectscale)
		mo.momz = FixedMul(v*n.z,mapobjectscale)*P_MobjFlip(mo)
	else
		mo.momz = v*mapobjectscale*P_MobjFlip(mo)
	end
	
	set_bounce_chances(mo,-1)
end

local function _current_reflect_mobj_think(mo)
	if mo.player._lvm_maxbouncetries == nil then
		mo.player._lvm_maxbouncetries = FRACUNIT
	end
	if mo.player._lvm_bouncetries == nil then
		set_bounce_chances(mo,mo.player._lvm_maxbouncetries,true)
	end
	if mo.player._lvm_landedfrombounce == nil then
		mo.player._lvm_landedfrombounce = -1
	end
	
	if P_IsObjectOnGround(mo) or mo.player._lvm_landedfrombounce == 0 then
		mo.player._lvm_landedfrombounce = max(-1,$ - 1)
	end
	
	if mo.player._lvm_landedfrombounce == 0 or
	mo.player.playerstate == 1 or --PST_DEAD
	mo.player.respawn.state ~= 0 then --RESPAWNST_NONE
		set_bounce_chances(mo,mo.player._lvm_maxbouncetries,true)
		--S_StartSound(mo,sfx_s3k40,mo.player)
	end
end

local function _current_reflect_player_think(p)
	if p._lvm_bouncetries ~= nil and p._lvm_maxbouncetries ~= nil then
		if p._lvm_bouncetries < p._lvm_maxbouncetries - 1 and p.bot then
			p.cmd.buttons = $|1<<6 --BT_RESPAWN
		end
	end
end

-- versioning

if lvm_reflectplane_version then
	if lvm_reflectplane_version >= REFLECTPLANE_VER then
		return
	end
end

rawset(_G, "lvm_reflectplane_version", REFLECTPLANE_VER)

rawset(_G, "lvm_reflect_mobj_think", _current_reflect_mobj_think)
rawset(_G, "lvm_reflect_player_think", _current_reflect_player_think)
rawset(_G, "lvm_reflect_do_bounce", _current_do_bounce)

if not lvm_reflectplane_loaded then
	addHook("SpecialExecute", function(activator, args)
		if not activator.mo then return end
		lvm_reflect_do_bounce(activator.mo, args)
	end, "LVM_REFLECTPLANE")

	addHook("MobjThinker",lvm_reflect_mobj_think,MT_PLAYER)
	--addHook("PlayerThink",lvm_reflect_player_think(p))
	rawset(_G, "lvm_reflectplane_loaded", true)
end
