-- custom boss for party phase teehee

-- objects
freeslot("MT_DRUIDCOFFIN", "MT_DRUIDKNIGHT", "S_DRUIDCOFFIN", "MT_FUCKORB", "MT_FUCKTRACER")
-- sounds
freeslot("sfx_drintr", "sfx_drfato", "sfx_drfat2", "sfx_drdoge", "sfx_drproj", "sfx_drint1", "sfx_drint2", "sfx_drint3", "sfx_drurip", "sfx_spbenl", "sfx_spbens", "sfx_bebo")
-- sprites
freeslot("SPR_PZKB", "SPR_BEBO", "S_DELTARUNEEXPLOSION")

local hearfaraway = {sfx_drintr, sfx_drfato, sfx_drfat2, sfx_drdoge, sfx_drproj, sfx_drint1, sfx_drint2, sfx_drint3, sfx_drurip}
--local captions = {"Parry", "Pain", "Pain", "Pain", "Enraged Hum", "Enraged", "Death"}
for k, v in ipairs(hearfaraway) do
	local sfx = sfxinfo[v]
	--sfx.caption = captions[k]
	sfx.flags = SF_X8AWAYSOUND
end
sfxinfo[sfx_spbenl].flags = SF_X8AWAYSOUND | SF_X4AWAYSOUND
sfxinfo[sfx_spbens].flags = SF_X8AWAYSOUND | SF_X4AWAYSOUND

if Music_AddTune then
	Music_AddTune("druid", 29, TN_LOOPING|TN_VAPES)
	Music_Remap("druid", "TOCNR")
end

-- Space definition
mobjinfo[MT_DRUIDCOFFIN] = {
	doomednum = 29665,
	spawnhealth = 1,
	mass = 1,
	spawnstate = S_INVISIBLE,
	flags = MF_SHOOTABLE|MF_PUSHABLE|MF_SLIDEME|MF_SOLID|MF_DONTENCOREMAP,
	radius = 32*FRACUNIT,
	height = 112*FRACUNIT,
}

mobjinfo[MT_DRUIDKNIGHT] = {
	spawnstate = S_INVISIBLE,
	--deathstate = S_INVISIBLE,
	spawnhealth = 200,
	damage = 1,
	flags = MF_SHOOTABLE|MF_ENEMY|MF_NOGRAVITY|MF_NOSQUISH|MF_DONTENCOREMAP|MF_DONTPUNT,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
}

mobjinfo[MT_FUCKORB] = {
	spawnstate = S_JAWZ1,
	deathstate = S_DELTARUNEEXPLOSION,
	spawnhealth = 200,
	deathsound = sfx_bebo,
	speed = 80*FRACUNIT,
	damage = 1,
	--seesound = sfx_drproj,
	flags = MF_MISSILE|MF_NOGRAVITY|MF_NOSQUISH|MF_DONTENCOREMAP,
	radius = 16*FRACUNIT,
	height = 64*FRACUNIT,
}

mobjinfo[MT_FUCKTRACER] = {
	spawnstate = S_JAWZ1,
	deathstate = S_DELTARUNEEXPLOSION,
	spawnhealth = 1000000,
	deathsound = sfx_bebo,
	--seesound = sfx_drproj,
	speed = 80*FRACUNIT,
	damage = 1,
	flags = MF_MISSILE|MF_NOGRAVITY|MF_NOSQUISH|MF_DONTENCOREMAP,
	radius = 16*FRACUNIT,
	height = 64*FRACUNIT,
}

states[S_DELTARUNEEXPLOSION] = {
	sprite = SPR_BEBO,
	frame = FF_FULLBRIGHT|FF_ANIMATE|A,
	tics = 15,
	var1 = 8,
	var2 = 2,
	nextstate = S_NULL
}

-- Spawn hitlag vfx since that isn't FUCKING exposed
local function SpawnHitlagEFX(mo, tics)
	local endtics = 0
	local starttics = 0
	while endtics < tics do
		local particle = max(1, FixedMul((tics * FRACUNIT) + (FRACUNIT/2), FRACUNIT*2/3) / FRACUNIT)
		particle = min($, 9)
		local ticsleft = tics - endtics
		particle = min($, ticsleft)
		local i = 0
		for i = 0,1 do
			local spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HITLAG)
			spark.target = mo
			spark.scale = mapobjectscale*2
			spark.angle = R_PointToAngle2(mo.x, mo.y, spark.x, spark.y)
			spark.state = spark.info.spawnstate + (particle - 1)
			if (i & 1) then
				spark.angle = $ + ANGLE_90
			end
			spark.hitlag = (starttics+1)
			spark.color = mo.color
			spark.colorized = true
		end
		starttics = $ + max(1, FixedMul((tics * FRACUNIT) + (FRACUNIT/2), FRACUNIT*2/3) / FRACUNIT)
		endtics = $ + particle
	end
	local soundid = sfx_dmga1
	if (leveltime & 1) then
		soundid = sfx_dmgb1
	end
	soundid = $ + ease.linear(
		min(FRACUNIT, FRACUNIT*tics/30),
		0, 3
	)
	S_StartSound(mo, soundid)
	P_StartQuake(tics, (tics*2) * mapobjectscale, 1536 * mapobjectscale, mo)
end

addHook("MobjSpawn", function(coffin)
	--coffin.sprite = SPR_THOK -- placeholder lmao
	local monitor = P_SpawnMobjFromMobj(coffin, 0, 0, 0, MT_MONITOR)
	monitor.flags = $ | MF_NOCLIPTHING
	monitor.flags = $ & ~(MF_SHOOTABLE|MF_PUSHABLE)
	coffin.tracer = monitor
	coffin.threshold = TICRATE
end, MT_DRUIDCOFFIN)

rawset(_G, 'L_ZCollide', function(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end)

addHook("MobjThinker", function(coffin)
	if coffin.tracer then
		P_MoveOrigin(coffin.tracer, coffin.x, coffin.y, coffin.z)
	end
	coffin.threshold = max(0, $-1)
end, MT_DRUIDCOFFIN)

local function fuck(mo, mo2)
	if mo.threshold then return end
	if mo2.type == MT_PLAYER and L_ZCollide(mo, mo2) then
		P_KillMobj(mo, mo2, mo2)
		return true
	end
end
addHook("MobjCollide", fuck, MT_DRUIDCOFFIN)
addHook("MobjMoveCollide", function(mo2, mo) fuck(mo, mo2) end, MT_DRUIDCOFFIN)

addHook("MobjDeath", function(coffin, inf, src)
	-- fuse gone, fucking wake up
	--print("uh")
	coffin.target = (inf and inf.valid and inf.type == MT_PLAYER) and inf or src
	if inf.player then -- player here, increment shit counter
		inf.player.ppzShitCounter = $+1
	end
	if P_RandomRange(0, 3) == 3 then
		--print("haha")
		local brak = P_SpawnMobjFromMobj(coffin, 0, 0, 0, MT_CYBRAKDEMON)
		brak.scale = $*2
		brak.target = coffin.target
		PPZ_InitHealthBar(brak, 12, 2, "BRAK EGGMAN")
		if Music_Play and coffin.target and coffin.target.player and coffin.target.player == consoleplayer then
			Music_Remap("druid", "VSBRAK")
			Music_Play("druid")
		end
		if coffin.target.player then
			brak.punt = coffin.target.player -- it can switch targets, but always reference the original!
		end
		P_KillMobj(coffin.tracer)
		return
	end
	local druid = P_SpawnMobjFromMobj(coffin, 0, 0, 0, MT_DRUIDKNIGHT)
	if coffin.target then
		druid.target = coffin.target
	end
	druid.sprite = SPR_PZKB
	druid.angle = coffin.angle
	--druid.scale = $*2
	druid.threshold = TICRATE
	druid.cvmem = 0
	druid.movefactor = 0
	druid.truehealth = 4
	druid.talking = 0
	if coffin.target and coffin.target.valid then
		druid.color = coffin.target.color
		if coffin.target.player and coffin.target.player.valid then
			druid.rember = coffin.target.player
		end
		if Music_Play and druid.target and druid.target.player and druid.target.player == consoleplayer then
			Music_Remap("druid", "TOCNR")
			Music_Play("druid", druid.target.player)
		end
	end
	P_KillMobj(coffin.tracer)
	P_SetObjectMomZ(druid, 6*druid.scale)
end, MT_DRUIDCOFFIN)

rawset(_G,'L_ThrustXYZ', function(mo,xyangle,zangle,speed,relative)
	local xythrust = P_ReturnThrustX(nil,zangle,speed)
	local zthrust = P_ReturnThrustY(nil,zangle,speed)
	if relative then
		P_Thrust(mo,xyangle,xythrust)		
		mo.momz = $+zthrust	
	else
		P_InstaThrust(mo,xyangle,xythrust)		
		mo.momz = zthrust	
	end
	return xythrust/FRACUNIT, zthrust/FRACUNIT
end)

rawset(_G,'L_TurnAngle', function(oldangle,newangle,factor)
	factor = $ or FRACUNIT/8
	return oldangle + FixedMul(newangle-oldangle,factor)
end)

rawset(_G,'L_GetZAngle', function(x1,y1,z1,x2,y2,z2)
	local xydist = R_PointToDist2(x1,y1,x2,y2)
	local zdist = z2-z1
	return R_PointToAngle2(0,0,xydist,zdist)
end)

rawset(_G,'L_DoBrakes', function(mo,factor)
	mo.momx = FixedMul($,factor)
	mo.momy = FixedMul($,factor)
	mo.momz = FixedMul($,factor)
end)

addHook("MobjThinker", function(druid)
	if not (druid.target and druid.target.valid) then
		if not (druid.rember and druid.rember.valid and (not druid.rember.spectator)) then
			-- find a player if remembered player no longer exists
			P_LookForPlayers(druid, 2048*mapobjectscale, true)
			if (druid.target and druid.target.valid and druid.target.player) and druid.rember then
				druid.target = druid.rember.mo
			end
		else
			if druid.rember.mo and druid.rember.mo.valid then
				druid.target = druid.rember.mo
			end
		end
	end
	druid.threshold = max(0, $-1)
	druid.talking = max(0, $-1)
	if druid.prematuredie then
		druid.prematuredie = max(0, $-1)
		if druid.prematuredie == 0 then
			P_RemoveMobj(druid)
			return true
		end
	end
	
	if druid.truehealth <= 2 and S_SoundPlaying(druid, sfx_spbenl) == false then
		S_StartSoundAtVolume(druid, sfx_spbenl, 128)
	end
	
	-- do not proceed.
	if not (druid.target and druid.target.valid) then return end
	
	if druid.threshold == 0 and druid.talking == 0 then
		druid.cvmem = druid.movefactor
		if druid.movefactor == 0 then
			druid.movefactor = 4
			druid.threshold = TICRATE*3+TICRATE/2
			S_StartSound(druid, sfx_drintr)
			S_StartSound(druid, sfx_drintr)
		elseif druid.movefactor == 1 then
			druid.extravalue1 = P_RandomRange(1, 2)
			druid.movefactor = 2
			S_StartSound(druid, sfx_drfato + (druid.extravalue1-1))
			S_StartSound(druid, sfx_drfato + (druid.extravalue1-1))
			druid.threshold = TICRATE
			if druid.extravalue1 == 1 then
				druid.extravalue2 = 4
			else
				druid.extravalue2 = 40
			end
		elseif druid.movefactor == 2 then
			-- full auto or fuller auto?
			if druid.extravalue1 == 1 then
				for i=-1,1 do
					for j = -2,2 do
						if i != 0 and (j % 2) == 0 then continue end
						--if i == 0 and (j % 2) != 0 then continue end
						--if (i == 1 or i == 4) and (j == 1 or j == 3) then continue end
						local missile = P_SpawnMobj(druid.x, druid.y, druid.z, MT_FUCKORB)
						missile.scale = druid.scale
						missile.target = druid
						missile.angle = druid.angle
						--missile.flags = $ | MF_NOGRAVITY
						--missile.threshold = TICRATE/2
						missile.color = SKINCOLOR_CRIMSON
						missile.colorized = true
						L_ThrustXYZ(missile, druid.angle + i*ANG20, druid.pitch + (j-1)*ANG10, 56*mapobjectscale, false)
						S_StartSound(missile, sfx_drproj)
					end
				end
				--print("hi")
			else
				-- fuller auto todo
				local missile = P_SpawnMobj(
					druid.x + P_RandomRange(-FRACUNIT*16, FRACUNIT*16), 
					druid.y + P_RandomRange(-FRACUNIT*16, FRACUNIT*16), 
					druid.z + P_RandomRange(-FRACUNIT*16, FRACUNIT*16), 
					MT_FUCKTRACER
				)
				missile.scale = druid.scale
				missile.target = druid
				missile.tracer = druid.target
				missile.angle = druid.angle
				--missile.flags = $ | MF_NOGRAVITY
				--missile.threshold = TICRATE/2
				missile.color = SKINCOLOR_BLUE
				missile.colorized = true
				S_StartSound(missile, sfx_drproj)
			end
			druid.extravalue2 = $ - 1
			druid.movefactor = druid.extravalue2 and 2 or 4
			druid.threshold = druid.extravalue1 == 1 and TICRATE/4 or 1
		elseif druid.movefactor == 4 then
			druid.movefactor = 1
			druid.threshold = TICRATE*2
			if not druid.hb then
				PPZ_InitHealthBar(druid, 200, 4, "MYSTERIOUS FLOATING CUBE (& CONE)")
				druid.hb = true
			end
			druid.momz = 0
		end
	end
	
	if druid.movefactor == 6 then
		druid.threshold = 1
		local trangle = R_PointToAngle2(druid.x, druid.y, druid.target.x, druid.target.y)
		druid.angle = L_TurnAngle($, trangle, FRACUNIT/8)
		druid.pitch = L_TurnAngle($, L_GetZAngle(druid.x, druid.y, druid.z, druid.target.x, druid.target.y, druid.target.z), FRACUNIT/8)
		L_ThrustXYZ(druid, druid.angle, druid.pitch, 24*mapobjectscale, false)
	end
	
	-- constantly follow the target
	if druid.cvmem > 0 and druid.movefactor != 6 then
		local trangle = R_PointToAngle2(druid.x, druid.y, druid.target.x, druid.target.y)
		druid.angle = L_TurnAngle($, trangle, FRACUNIT/8)
		druid.pitch = L_TurnAngle($, L_GetZAngle(druid.x, druid.y, druid.z, druid.target.x, druid.target.y, druid.target.z), FRACUNIT/8)
		
		-- compare distance
		local dist = P_AproxDistance(P_AproxDistance(
			druid.x - druid.target.x,
			druid.y - druid.target.y
		), druid.z - druid.target.z)
		dist = abs($)
		
		-- dashing
		L_DoBrakes(druid, FRACUNIT*95/100)
		--if druid.cusval == 0 then
		-- too far, get closer
		if dist > 1024*druid.scale then
			L_ThrustXYZ(druid, trangle, druid.pitch, 10*druid.scale, true)
			if druid.target.z >= druid.z then
				-- raise up
				if druid.target.floorz == druid.floorz then
					druid.momz = 56*mapobjectscale
				else
					druid.momz = FixedMul($, FRACUNIT*3/2)
				end
			else
				druid.momz = $/2
				if P_RandomRange(0, 3) == 0 then
					druid.momz = 0
				end
			end
		else
			-- circle around
			druid.momx = P_ReturnThrustX(druid, druid.cusval, FRACUNIT)
			druid.momy = P_ReturnThrustY(druid, druid.cusval, FRACUNIT)
			druid.cusval = $ + (ANG1/2)
		end
		--else
		--	druid.cusval = $ - 1
		--end
	end
end, MT_DRUIDKNIGHT)

addHook("MobjDamage", function(druid, inf, src)
	--print(inf.type)
	--print(src)
	if druid.movefactor == 0 or druid.movefactor == 4 then return true end
	if druid.talking then return true end
	if druid.health == 200 then
		druid.nextmilestone = druid.health - 50
	end
	if inf then
		druid.health = $ - min(25, max(15, mobjinfo[inf.type].damage*15))
		druid.talking = 10
		druid.hitlag = 10
		SpawnHitlagEFX(druid, druid.hitlag)
		--print(druid.health)
	end
	if druid.health < 200 and druid.health < druid.nextmilestone then
		druid.truehealth = $ - 1
		druid.nextmilestone = $ - 50
		if druid.truehealth <= 0 then
			druid.alreadydied = true
			P_KillMobj(druid)
			return true
		end
	else
		return true
	end
	-- i hate sound
	S_StartSoundAtVolume(druid, sfx_drint1 + (3 - druid.truehealth), 255)
	S_StartSoundAtVolume(druid, sfx_drint1 + (3 - druid.truehealth), 255)
	S_StartSoundAtVolume(druid, sfx_drint1 + (3 - druid.truehealth), 255)
	S_StartSoundAtVolume(druid, sfx_drint1 + (3 - druid.truehealth), 255)
	-- we're talking, dont do shit
	druid.talking = TICRATE*3
	if druid.truehealth == 2 then
		druid.color = SKINCOLOR_CRIMSON
		druid.colorized = true
		S_StartSound(druid, sfx_spbens)
	end
	return true
end, MT_DRUIDKNIGHT)

addHook("MobjDeath", function(druid)
	druid.sprite = SPR_PZKB
	druid.movefactor = 6
	S_StartSound(druid, sfx_drurip)
	S_StartSound(druid, sfx_drurip)
	druid.flags = $ | MF_MISSILE
	druid.alreadydied = true
	if Music_Stop and druid.target and druid.target.player and druid.target.player == consoleplayer then
		Music_Stop("druid", druid.target.player)
	end
	druid.prematuredie = 4*TICRATE
	return true
end, MT_DRUIDKNIGHT)

addHook("MobjRemoved", function(druid)
	local explosion = P_SpawnMobjFromMobj(druid, 0, 0, 0, MT_THOK)
	explosion.state = S_DELTARUNEEXPLOSION
	explosion.fuse = TICRATE*3
	explosion.scale = $*2
	druid.hbdeferDie = true
	S_StartSound(explosion, sfx_bebo)
	P_RadiusAttack(explosion, explosion, druid.radius, DMG_TUMBLE, true)
	if druid.target.type == MT_PLAYER then
		druid.target.player.ppzShitCounter = max(0, $-1)
	end
end, MT_DRUIDKNIGHT)

addHook("MobjThinker", function(tracer)
	if not (tracer.tracer and tracer.tracer.valid) then return end
	local trangle = R_PointToAngle2(tracer.x, tracer.y, tracer.tracer.x, tracer.tracer.y)
	tracer.angle = L_TurnAngle($, trangle, FRACUNIT/8)
	tracer.pitch = L_TurnAngle($, L_GetZAngle(tracer.x, tracer.y, tracer.z, tracer.tracer.x, tracer.tracer.y, tracer.tracer.z), FRACUNIT/8)
	L_ThrustXYZ(tracer, tracer.angle, tracer.pitch, 32*mapobjectscale, false)
end, MT_FUCKTRACER)

-- do not collide with others or target itself
local function ignorepls(mo, mo2)
	if mo2 == mo.target then return false end
	if mo2.type == mo.type then return false end
	if mo2.type == MT_DRUIDKNIGHT and L_ZCollide(mo, mo2) then
		P_DamageMobj(mo2, mo, mo, 15)
		return true
	end
end

addHook("MobjCollide", ignorepls, MT_FUCKTRACER)
addHook("MobjMoveCollide", ignorepls, MT_FUCKTRACER)
addHook("MobjCollide", ignorepls, MT_FUCKORB)
addHook("MobjMoveCollide", ignorepls, MT_FUCKORB)