-- LUA SCRIPT FOR THE VARIOUS SHIT IN PARTY PHASE ZONE...
-- PROBABLY UNFINISHED.

-- Objects
freeslot("MT_PPZSPACE")

-- Sprites
freeslot("SPR_PZSP")

-- Space types
local SPACE_NONE 		= 0
local SPACE_RINGGAIN 	= 1
local SPACE_RINGDRAIN 	= 2
local SPACE_EVENT		= 3
local SPACE_CHANCE		= 4

local spacenames = {
	[SPACE_NONE] = "[ERROR]",
	[SPACE_RINGGAIN] = "\x88".."[RING GAIN]",
	[SPACE_RINGDRAIN] = "\x85".."[RING DRAIN]",
	[SPACE_EVENT] = "\x8B".."[RANDOM EVENT]",
	[SPACE_CHANCE] = "\x81".."[CHANCE TIME]",
}

local hudttl = {
	[SPACE_NONE] = "YOU FUCKED UP",
	[SPACE_RINGGAIN] = "PAY DAY",
	[SPACE_RINGDRAIN] = "TAX DAY",
	[SPACE_EVENT] = "FEELING LUCKY",
	[SPACE_CHANCE] = "CHANCE TIME",
}

-- Chance time types
local CHANCE_NONE		= 0
-- race only
local CHANCE_RINGS 		= 1
--local CHANCE_EMPTYRINGS	= 2
local CHANCE_POSITION	= 2
-- race and bottl
local CHANCE_DIE		= 3
local CHANCE_ITEMS		= 4
-- bottl only
local CHANCE_POINTS		= 5
local CHANCE_BUMPERS	= 6
local CHANCE_SPHERES	= 7

-- Chance time rules
local CHANCERULE_NONE	= 0
local CHANCERULE_RIGHT	= 1
local CHANCERULE_LEFT	= 2
local CHANCERULE_SWBH	= 3 -- Swap or both! Your loss.

local fmt = string.format

-- Hardcoded sets of types
-- {type, rule, graphic, condition}
local ct_sets = {
	{CHANCE_RINGS, CHANCERULE_LEFT, "P_RG%d", do return (gametyperules & GTR_SPHERES) ~= GTR_SPHERES end},
	{CHANCE_RINGS, CHANCERULE_RIGHT, "P_RG%d", do return (gametyperules & GTR_SPHERES) ~= GTR_SPHERES end},
	{CHANCE_RINGS, CHANCERULE_SWBH, "P_RG%d", do return (gametyperules & GTR_SPHERES) ~= GTR_SPHERES end},
	{CHANCE_POSITION, CHANCERULE_SWBH, "P_POS3", do return true end},
	{CHANCE_DIE, CHANCERULE_SWBH, "P_DIE3", do return true end},
	{CHANCE_ITEMS, CHANCERULE_SWBH, "P_ITEM3", do return true end},
	{CHANCE_POINTS, CHANCERULE_LEFT, "P_BNS%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_POINTS, CHANCERULE_RIGHT, "P_BNS%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_POINTS, CHANCERULE_SWBH, "P_BNS%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_BUMPERS, CHANCERULE_LEFT, "P_BMPR%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_BUMPERS, CHANCERULE_RIGHT, "P_BMPR%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_BUMPERS, CHANCERULE_SWBH, "P_BMPR%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_SPHERES, CHANCERULE_LEFT, "P_SPRE%d", do return (gametyperules & GTR_BUMPERS) == GTR_BUMPERS end},
	{CHANCE_SPHERES, CHANCERULE_RIGHT, "P_SPRE%d", do return (gametyperules & GTR_SPHERES) == GTR_SPHERES end},
	{CHANCE_SPHERES, CHANCERULE_SWBH, "P_SPRE%d", do return (gametyperules & GTR_SPHERES) == GTR_SPHERES end},
}

-- returns a table
-- first element is the function to run, returns a string description of what it did
-- second is the condition if it should run
local chancetime_funcs = {
	[CHANCE_NONE] = {function(v1, v2, r) end, do return false end},		-- why?
	[CHANCE_RINGS] = {function(v1, v2, r)
		if r == CHANCERULE_RIGHT then
			-- transfer rings to v2
			v2.rings = $+v1.rings
			v1.rings = 0
			return fmt("%s steals %s's rings!", v2.name, v1.name)
		elseif r == CHANCERULE_LEFT then
			-- transfer rings to v1
			v1.rings = $+v2.rings
			v2.rings = 0
			return fmt("%s steals %s's rings!", v1.name, v2.name)
		elseif r == CHANCERULE_SWBH then
			-- swap rings
			-- this is very valid syntax, hmm yes
			v1.rings, v2.rings = $2, $1
			return fmt("%s switches rings with %s!", v1.name, v2.name)
		end
	end, do return (!(gametyperules & GTR_SPHERES)) end},
	[CHANCE_POSITION] = {function(v1, v2, r)
		local mo1 = v1.mo
		local mo2 = v2.mo
		-- swap positions
		local oldx, oldy, oldz = mo1.x, mo1.y, mo1.z
		P_SetOrigin(mo1, mo2.x, mo2.y, mo2.z + mo2.height)
		P_SetOrigin(mo2, oldx, oldy, oldz + mo1.height)
		return fmt("%s and %s switch positions!", v1.name, v2.name)
	end, do return (!(gametyperules & GTR_BUMPERS)) end},
	[CHANCE_DIE] = {function(v1, v2, r)
		local mo1 = v1.mo
		local mo2 = v2.mo
		-- BOTH DIE
		P_KillMobj(mo2, nil, nil)
		P_KillMobj(mo1, nil, nil)
		return fmt("Both %s and %s fucking die", v1.name, v2.name)
	end, do return true end},
	[CHANCE_ITEMS] = {function(v1, v2, r)
		v1.itemtype, v2.itemtype = $2, $1
		v1.itemamount, v2.itemamount = $2, $1
		return fmt("%s switches items with %s!", v1.name, v2.name)
	end, do return true end},
	-- im not even gonna bother commenting these anymore
	[CHANCE_POINTS] = {function(v1, v2, r)
		if r == CHANCERULE_RIGHT then
			v2.roundscore = $+v1.roundscore
			v1.roundscore = 0
			return fmt("%s steals %s's points!", v2.name, v1.name)
		elseif r == CHANCERULE_LEFT then
			v1.roundscore = $+v2.roundscore
			v2.roundscore = 0
			return fmt("%s steals %s's points!", v1.name, v2.name)
		elseif r == CHANCERULE_SWBH then
			v1.roundscore, v2.roundscore = $2, $1
			return fmt("%s switches points with %s!", v1.name, v2.name)
		end
	end, do return (gametyperules & GTR_BUMPERS) end},
	[CHANCE_BUMPERS] = {function(v1, v2, r)
		if r == CHANCERULE_RIGHT then
			-- v1's items/bumpers go to v2
			v2.mo.health = $+v1.mo.health
			v1.mo.health = 1 -- sorry v1
			return fmt("%s steals %s's bumpers!", v2.name, v1.name)
		elseif r == CHANCERULE_LEFT then
			-- v2's items/bumpers go to v1
			v1.mo.health = $+v2.mo.health
			v2.mo.health = 1 -- sorry v2
			return fmt("%s steals %s's bumpers!", v1.name, v2.name)
		elseif r == CHANCERULE_SWBH then
			-- swap items and bumpers
			v1.mo.health, v2.mo.health = $2, $1
			return fmt("%s switches bumpers with %s!", v1.name, v2.name)
		end
	end, do return (gametyperules & GTR_BUMPERS) end},
	[CHANCE_SPHERES] = {function(v1, v2, r)
		if r == CHANCERULE_RIGHT then
			v2.spheres = $+v1.spheres
			v1.spheres = 0
			return fmt("%s steals %s's spheres!", v2.name, v1.name)
		elseif r == CHANCERULE_LEFT then
			v1.spheres = $+v2.spheres
			v2.spheres = 0
			return fmt("%s steals %s's spheres!", v1.name, v2.name)
		elseif r == CHANCERULE_SWBH then
			v1.spheres, v2.spheres = $2, $1
			return fmt("%s switches spheres with %s!", v1.name, v2.name)
		end
	end, do return (gametyperules & GTR_SPHERES) end},
}
-- This is a constant. Fuck you
local ctfuncs_len = #chancetime_funcs

local CHANCESTATE_NONE = 0
local CHANCESTATE_PICKINGV1 = 1
local CHANCESTATE_PICKINGRULE = 2
local CHANCESTATE_PICKINGV2 = 3

-- Chance time global
local g_chanceTime = {
	active = false,				-- not active, no shit sherlock
	victim1 = nil,				-- left victim
	victim2 = nil,				-- right victim
	interoggator = nil,			-- who initiated the chance time
	type = CHANCE_NONE,			-- chance time type
	rule = CHANCERULE_NONE,		-- chance rule
	sets = {},					-- current sets
	-- while chance time is being selected....
	victim1list = {},
	victim2list = {},
	state = CHANCESTATE_NONE,
	-- for roulette
	tics = 0,
	idx = 0,
	typeidx = 0,
	elapsed = 0,
	curLen = 0,
	sound = 0,
	delay = 0,
	-- for hud
	desc = "",
	rulegfx = "",
	desctime = 0,
	hud_active = false,
	hud_trans = {-1, -1, -1, -1},
	trueelapsed = 0,
	--spaces = {}					-- collection of chance time spaces
}

local function resetchancetime()
	g_chanceTime.victim1 = nil
	g_chanceTime.victim2 = nil
	g_chanceTime.interoggator = nil
	g_chanceTime.type = CHANCE_NONE
	g_chanceTime.rule = CHANCERULE_NONE
	g_chanceTime.state = CHANCESTATE_NONE
	g_chanceTime.victim1list = {}
	g_chanceTime.victim2list = {}
	g_chanceTime.tics = 0
	g_chanceTime.idx = 0
	g_chanceTime.elapsed = 0
	g_chanceTime.curLen = 0
	g_chanceTime.sound = 0
	g_chanceTime.desc = ""
	g_chanceTime.rulegfx = ""
	g_chanceTime.desctime = 0
	g_chanceTime.delay = 0
	g_chanceTime.hud_trans = {-1, -1, -1, -1}
	g_chanceTime.trueelapsed = 0
	g_chanceTime.sets = {}
end

rawset(_G, 'L_Shuffle', function(t)
    for n = #t, 1, -1 do
        local k = P_RandomRange(1, n)
        t[n], t[k] = t[k], t[n]
    end
    return t
end)

local g_miscStuff = {
	fuckedSpace = SPACE_NONE,
	double = false,
	pcount = 0,
	redspaceconfirmed = 0,
}

-- Player count lmao
addHook("PreThinkFrame", function()
	g_miscStuff.pcount = 0
	for p in players.iterate do
		if p.spectator then continue end
		if not (p.mo and p.mo.valid) then continue end
		g_miscStuff.pcount = $ + 1
	end
end)

-- Heh.
local excludeArchive = { -- Archiving is forbidden
	["function"] = true, 
	["thread"] = true, 
	["proto"] = true, 
	["upval"] = true
}
local allowUDArchive = { -- Archiving is allowed :)
	["mobjinfo_t"] = true, 
	["state_t"] = true, 
	["mobj_t"] = true, 
	["player_t"] = true, 
	["mapthing_t"] = true, 
	["vertex_t"] = true, 
	["line_t"] = true, 
	["side_t"] = true, 
	["subsector_t"] = true, 
	["sector_t"] = true, 
	["ffloor_t"] = true, 
	["polyobj_t"] = true, 
	["slope_t"] = true, 
	["mapheader_t"] = true, 
	["skincolor_t"] = true, 
}
local function checksanity(t, net)
	for k, v in ipairs(t) do
		-- Table, recursively check
		if type(v) == "table" then checksanity(v, net) end
		-- Excluded from synching and potentially losing causing a sync failure.
		if excludeArchive[type(v)] then continue end 
		-- Ditto.
		if type(v) == "userdata" and (not allowUDArchive[userdataType(v)]) then continue end
		v = net($)
	end
end
-- Hopefully this doesn't cause any bad issues...
addHook("NetVars", function(net)
	checksanity(g_chanceTime, net)
	g_miscStuff.fuckedSpace = net($)
	g_miscStuff.double = net($)
	g_miscStuff.redspaceconfirmed = net($)
end)

local pcount = 0
-- Player count lmao
addHook("PreThinkFrame", function()
	pcount = 0
	for p in players.iterate do
		if p.spectator then continue end
		if not (p.mo and p.mo.valid) then continue end
		pcount = $ + 1
		p.mo.lastmomz = p.mo.momz
	end
end)

-- event tags
local ACS_FORCESPACE 	= 9999
local ACS_SPAWNMINES 	= 9998
local ACS_PAPERREDD 	= 9997
local ACS_DISABLECTS	= 9996
local ACS_ENABLECTS		= 9995
local ACS_STARTTIME		= 9994

-- Specifically for ACS....

-- THING_SPAWNEX
addHook("SpecialExecute", function(_, args, stringargs)
	-- Fun fact... you can only have ONE stringarg
	-- The first string argument is ALWAYS the Lua_Execute identifier
	-- Unless you can make some trickery with it.... You only have O N E
	if not stringargs[1] then
		print("THING_SPAWNEX: No type set! What object were you even gonna spawn?")
	end
	
	local t = _G[stringargs[1]]
	local x = args[2]
	local y = args[3]
	local z = args[4]
	
	-- Ok mister
	if not (x and y and z) then
		print("THING_SPAWNEX: No coordinates set!")
		return
	end
	
	local m = P_SpawnMobj(x, y, z, t)
	m.angle = args[5] or 0
	m.threshold = args[6] or 0
	m.movecount = 0 -- hmmm
	m.scale = args[7] or FRACUNIT
	m.momz = args[8] or 0
	-- The TID is for when you want to set OTHER parameters laterer
	m.tid = args[9] or 0
end, "THING_SPAWNEX")

-- RESETSHIT
addHook("SpecialExecute", function(_, args, stringargs)
	-- all this does currently lmao
	g_miscStuff.redspaceconfirmed = 0
	g_miscStuff.fuckedSpace = 0
end, "RESETSHIT")

local lookingforatag = -1
-- nihahaha
addHook("MobjThinker", function(mo)
	-- if netgame then return end
	if lookingforatag == -1 then return end;
	-- This works. Apparently.
	if mo.tid == lookingforatag then
		mo.threshold = g_miscStuff.fuckedSpace
		if server.mo then
			mo.tracer = server.mo
		end
		-- UNDOCUMENTED FEATURE: 
		-- ball switches have a way to defer their associated action
		mo.extravalue2 = 1
		lookingforatag = -1
	end
end, MT_BALLSWITCH_BALL)

-- Why isn't this exposed?
local function L_TimeFrac(tics, duration)
	return tics < duration and (tics * FRACUNIT) / duration or FRACUNIT
end
local M_TimeFrac = M_TimeFrac or L_TimeFrac -- M_TimeFrac may be exposed in the future idk

local function K_SpawnMagicianParticles(mo, spread)
	local i = 0
	local target = mo.target

	if not (target and target.valid) then
		target = mo
	end

	for i=0,15 do
		local hmomentum = P_RandomRange(spread * -1, spread) * mo.scale
		local vmomentum = P_RandomRange(spread * -1, spread) * mo.scale
		local color = P_RandomKey(#skincolors)

		local ang = FixedAngle(P_RandomRange(0, 359)*FRACUNIT)
		local flip = 1

		if (i & 1) then
			ang = $ + ANGLE_90
		else
			ang = $ - ANGLE_90
		end

		-- sprzoff for Garden Top!!
		local dust = P_SpawnMobjFromMobj(mo,
			FixedMul(mo.radius, cos(ang)),
			FixedMul(mo.radius, sin(ang)),
			((target.height) + target.sprzoff), (i%3 == 0) and MT_SIGNSPARKLE or MT_SPINDASHDUST
		)
		flip = P_MobjFlip(dust)

		dust.momx = target.momx + FixedMul(hmomentum, cos(ang))
		dust.momy = target.momy + FixedMul(hmomentum, sin(ang))
		dust.momz = vmomentum * flip
		dust.scale = $*4
		dust.frame = $|FF_SUBTRACT|FF_TRANS90
		dust.color = color
		dust.colorized = true
		dust.hitlag = 0
	end
end

-- Event functions (one time)
local events = {
	function(p) -- restore spheres or rings
		if (gametyperules & GTR_SPHERES) then
			p.spheres = 40
		else
			p.rings = 20
		end
		return "You got mail! (Max rings/spheres.)"
	end,
	function(p) -- random powerup
		K_GivePowerUp(p, P_RandomRange(FIRSTPOWERUP, LASTPOWERUP), 30*TICRATE)
		return "Lucky block? (Random powerup for 30 seconds.)"
	end,
	function(p) -- die
		if (gametyperules & GTR_BUMPERS) then
			P_DamageMobj(p.mo, nil, nil, 1, DMG_NORMAL)
		else
			P_KillMobj(p.mo, nil, nil)
		end
		return "Funeral fees. (Die/lose a bumper.)"
	end,
	function(p) -- randomitem
		-- strip items first
		K_StripItems(p)
		-- strip others but invinc and grow timers
		local oldinvinc = p.invincibilitytimer
		local oldgrow = p.growshrinktimer
		K_StripOther(p)
		p.invincibilitytimer = oldinvinc
		p.growshrinktimer = oldgrow
		-- NOW give the item
		p.itemtype = P_RandomRange(1, NUMKARTITEMS-1)
		p.itemamount = 1
		return "Christmas present. (Random item.)"
	end,
	function(p) -- fuck spaces
		g_miscStuff.fuckedSpace = P_RandomRange(1, 3)
		lookingforatag = ACS_FORCESPACE
		return "Uh oh. (Spaces next reroll are forced to be "..spacenames[g_miscStuff.fuckedSpace].."\x80"..")"
	end,
	function(p) -- gayyy
		if not netgame then
			print("\x82".."[ALERT]".."\x80 "..p.name.." is gay!")
		else
			chatprint("\x82".."[ALERT]".."\x80 "..p.name.." is gay!")
		end
		return "No offense... but... (Called out in chat.)"
	end,
	function(p) -- double or sink
		if p.itemtype then
			p.itemamount = $*2
			return "Give it to the next person? (x2 current item.)"
		end
		-- strip items first
		K_StripItems(p)
		-- strip others but invinc and grow timers
		local oldinvinc = p.invincibilitytimer
		local oldgrow = p.growshrinktimer
		K_StripOther(p)
		p.invincibilitytimer = oldinvinc
		p.growshrinktimer = oldgrow
		-- kitchen gun
		p.itemtype = KITEM_KITCHENSINK
		p.itemamount = 1
		return "Go on, do a crime. (Free sink!)"
	end,
	function(p) -- next person gets 2 spaces free
		g_miscStuff.double = true
		return "Fuck. (2x effects for next person.)"
	end,
	function(p) -- forced ironman
		local maxskins = 0
		p.ppzLastSkin = $ or 0
		local usable = {}
		for i=0,#skins do
			if not (skins[i] and skins[i].valid) then continue end
			if i == p.ppzLastSkin then continue end
			-- commented out for ultiate fun.
			-- if (skins[i].flags & SF_IRONMAN) then continue end
			table.insert(usable, {
				name = skins[i].name,
				speed = skins[i].kartspeed,
				weight = skins[i].kartweight,
			})
		end
		local s = usable[P_RandomRange(1, #usable)]
		p.mo.skin = s.name
		p.kartspeed = s.speed
		p.kartweight = s.weight
		-- add weight if possible
		p.kartweight = $ + p.ppzAddWeight
		
		-- handle magician box
		S_StartSound(p.mo, sfx_kc33)
		S_StartSound(p.mo, sfx_cdfm44)
		
		local parent = p.mo
		local baseangle = P_RandomRange(0, 359)
		local j = 0
		
		for j=0,5 do
			local box = P_SpawnMobjFromMobj(parent, 0, 0, 0, MT_MAGICIANBOX)
			box.target = parent
			box.angle = FixedAngle((baseangle + j*90)*FRACUNIT)
			box.flags2 = $ | MF2_AMBUSH
			box.renderflags = $ | parent.renderflags
			box.extravalue1 = 10
			box.extravalue2 = 5*TICRATE/4
			box.cusval = (j == 5) and 1 or 0
			if j > 3 then
				-- >state 'S_MAGICIANBOX_TOP' does not exist.
				-- >ok
				box.state = (j == 4) and $+1 or $+2
				box.renderflags = $ | RF_NOSPLATBILLBOARD
				box.angle = FixedAngle(baseangle*FRACUNIT)
			end
		end
		K_SpawnMagicianParticles(parent, 10)
		
		return "jironman (Change character, voices unchanged.)"
	end,
	function(p) -- you know im phat
		p.ppzUpdateFollowerScale = $ <= 0 and p.mo.scale*2 or $*2
		return "phat (x2 follower scale.)"
	end,
	function(p) -- im phat
		p.ppzUpdateHorizScale = $ + FRACUNIT
		p.ppzAddWeight = 2
		p.kartweight = $ + p.ppzAddWeight
		p.mo.flags = $ | MF_NOSQUISH
		return "'Weird Al' Yankovic - Fat (x2 horizontal scale, +2 weight.)"
	end,
	function(p) -- mine blast
		lookingforatag = ACS_SPAWNMINES
		return "Mine blast! (Spawn a landmine for every space.)"
	end,
	function(p) -- monitor blast
		lookingforatag = ACS_PAPERREDD
		g_miscStuff.redspaceconfirmed = 1
		return "Risk with reward. (Spawn a random paper item for every "..spacenames[SPACE_RINGDRAIN].."\x80".." space next reroll.)"
	end,
	function(p) -- monitor blast
		local c, _ = ColorOpposite(p.skincolor)
		p.skincolor = c
		p.mo.color = c
		return "Opposite day. (Skin color is the opposite of your current one. Permanent.)"
	end,
	function(p) -- monitor blast
		local druiddummy = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_DRUIDCOFFIN)
		druiddummy.momz = 30 * druiddummy.scale
		druiddummy.angle = ANGLE_270
		return "Spawn a monitor? (???)"
	end,
}

-- Space definition
mobjinfo[MT_PPZSPACE] = {
	doomednum = 29666,
	spawnstate = S_INVISIBLE,
	flags = MF_SPECIAL|MF_DONTENCOREMAP,
	radius = 56*FRACUNIT,
	height = 64*FRACUNIT,
}

local function copyslope(mo, slope)
	if not slope then return end
	P_CreateFloorSpriteSlope(mo)
	local floorslope = slope
	-- You might be saying. Why an additional FRACUNIT?
	-- Legacy GL is so fucking ass
	-- The lower splats won't render without this otherwise.
	-- Fuck this renderer
	mo.floorspriteslope.o = {x = floorslope.o.x, y = floorslope.o.y, z = floorslope.o.z + FRACUNIT}
	mo.floorspriteslope.zdelta = floorslope.zdelta
	mo.floorspriteslope.zangle = floorslope.zangle
	mo.floorspriteslope.xydirection = floorslope.xydirection
end

-- Spawn, dammit
addHook("MapThingSpawn", function(mo, mt)
	-- Adjust scale
	mo.scale = $*4
	-- Set space information
	mo.sprite = SPR_PZSP
	mo.frame = E
	local spacetype = mt.args[0]
	if spacetype > SPACE_NONE and spacetype <= SPACE_CHANCE then
		mo.frame = spacetype-1
		mo.extravalue1 = spacetype
	end
	mo.frame = $ | FF_FULLBRIGHT | FF_FLOORSPRITE
	mo.renderflags = $ | RF_SLOPESPLAT | RF_NOSPLATBILLBOARD
	-- inactive thingy
	mo.target = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
	mo.target.target = mo
	mo.target.sprite = SPR_PZSP
	mo.target.frame = E | FF_FULLBRIGHT | FF_FLOORSPRITE
	mo.target.renderflags = mo.renderflags | RF_SUBTRACT | (RF_DONTDRAWP1|RF_DONTDRAWP2|RF_DONTDRAWP3|RF_DONTDRAWP4)
	mo.target.scale = mo.scale
	-- flash lmao
	mo.tracer = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
	mo.tracer.target = mo
	mo.tracer.sprite = SPR_PZSP
	mo.tracer.frame = F | FF_FULLBRIGHT | FF_FLOORSPRITE
	mo.tracer.renderflags = mo.renderflags | RF_DONTDRAW | RF_REDUCEVFX
	mo.tracer.scale = mo.scale
	-- shit fix
	if P_IsObjectOnGround(mo) then
		copyslope(mo, mo.subsector.sector.f_slope)
		copyslope(mo.target, mo.subsector.sector.f_slope)
		copyslope(mo.tracer, mo.subsector.sector.f_slope)
	end
	-- players targetted by this shit
	mo.thresholdlist = {}
	--mo.tracerlist = {}
end, MT_PPZSPACE)

local function K_AwardPlayerRings(p, rings, overload)
	local superring = 0
	if not overload then
		local totalrings = (p.rings + p.pickuprings) + p.superring
		
		if (totalrings + rings) > 20 then
			-- no negatives, fool
			if totalrings >= 20 then return end
			rings = 20 - totalrings
		end
	end
	
	superring = p.superring + rings
	if superring > p.superring then
		p.superring = superring
	end
end

addHook("TouchSpecial", function(special, toucher)
	-- KILL YOURSELF
	if not (toucher.player and toucher.player.valid) then return true end
	
	local p = toucher.player
	if p.ppzGimmickTime > 0 then return true end
	if special.thresholdlist[#p] then return true end -- no cheesing on a single space you moron
	if special.cvmem then return true end -- currently rerolling, do nothing
	if special.cusval then return true end -- manually disabled
	
	-- check space type
	local spacetype = special.extravalue1
	if spacetype == SPACE_NONE then return true end -- fucking NOTHING
	-- actual space, so add gimmick time
	p.ppzGimmickTime = TICRATE*3
	p.ppzLastSpace = spacetype

	-- award rings
	if spacetype == SPACE_RINGGAIN then
		S_StartSound(toucher, sfx_kc48)
		K_AwardPlayerRings(p, 10, true)
		p.ppzEventName = "Bank error in your favor. (+10 rings.)"
	-- drain rings
	elseif spacetype == SPACE_RINGDRAIN then
		S_StartSound(toucher, sfx_antiri)
		local r = 10
		if r > p.rings then
			r = p.rings
		end
		if (gametyperules & GTR_SPHERES) then
			p.spheres = $ - 10
		else
			p.rings = $ - r
		end
		p.ppzEventName = "Doctor's fees. (-10 rings/spheres.)"
	elseif spacetype == SPACE_EVENT then
		p.ppzEventName = events[P_RandomRange(1, #events)](p)
		if g_miscStuff.double then
			p.ppzEventName = events[P_RandomRange(1, #events)](p)
			g_miscStuff.double = false
		end
		S_StartSound(toucher, sfx_kc48)
	elseif spacetype == SPACE_CHANCE and not g_chanceTime.hud_active then
		if g_miscStuff.pcount >= 3 then
			p.ppzEventName = "Uh oh."
			g_chanceTime.active = true
			g_chanceTime.hud_active = true
			resetchancetime()
			g_chanceTime.state = 1
			g_chanceTime.hud_trans[g_chanceTime.state] = 0
			g_chanceTime.interoggator = p
			-- fill victim 1 list first ofc
			for q in players.iterate do
				if q.spectator then continue end
				if not (q.mo and q.mo.valid) then continue end
				-- Yes, the player interoggating is not included.
				-- When in doubt, blame the person who initiated a chance time.
				-- Their fault, technically.
				if q == p then continue end
				table.insert(g_chanceTime.victim1list, q)
			end
			L_Shuffle(g_chanceTime.victim1list)
			g_chanceTime.curLen = #g_chanceTime.victim1list
			lookingforatag = ACS_DISABLECTS
		else
			p.ppzEventName = "Chance time isn't available..."
			p.ppzEventName = $ + "\n" + events[P_RandomRange(1, #events)](p)
			if g_miscStuff.double then
				p.ppzEventName = events[P_RandomRange(1, #events)](p)
				g_miscStuff.double = false
			end
			S_StartSound(toucher, sfx_eggspr)
		end
	end
	
	table.insert(p.ppzCurrentLog, spacetype-1)
	
	-- darken ONLY for that player
	special.thresholdlist[#p] = TICRATE*8
	if displayplayers[0] == p then
		special.target.renderflags = ($ & ~RF_DONTDRAWP1)
	elseif displayplayers[1] == p then
		special.target.renderflags = ($ & ~RF_DONTDRAWP2)
	elseif displayplayers[2] == p then
		special.target.renderflags = ($ & ~RF_DONTDRAWP3)
	elseif displayplayers[3] == p then
		special.target.renderflags = ($ & ~RF_DONTDRAWP4)
	end
	return true
end, MT_PPZSPACE)

addHook("MobjThinker", function(mo)
	if mo.cusval then return end
	-- handle flash
	if mo.threshold then
		if mo.threshold % 2 == 0 then
			mo.tracer.renderflags = ($ & ~RF_DONTDRAW)
		else
			mo.tracer.renderflags = ($ | RF_DONTDRAW)
		end
		mo.threshold = $-1
	else
		mo.tracer.renderflags = ($ | RF_DONTDRAW)
	end
	-- handle disabling
	for i=0,#players-1 do
		mo.thresholdlist[i] = $ or 0
		mo.thresholdlist[i] = max(0, $-1)
		if mo.thresholdlist[i] <= 0 and players[i] and players[i].valid then
			local p = players[i]
			if displayplayers[0] == p then
				mo.target.renderflags = ($ | RF_DONTDRAWP1)
			elseif displayplayers[1] == p then
				mo.target.renderflags = ($ | RF_DONTDRAWP2)
			elseif displayplayers[2] == p then
				mo.target.renderflags = ($ | RF_DONTDRAWP3)
			elseif displayplayers[3] == p then
				mo.target.renderflags = ($ | RF_DONTDRAWP4)
			end
		end
	end
end, MT_PPZSPACE)

addHook("PlayerSpawn", function(p)
	-- gimmick time
	p.ppzGimmickTime = 0
	p.ppzEventName = ""
	p.ppzLastSpace = SPACE_NONE
	-- scales
	p.ppzAddWeight = 0
	p.ppzUpdateFollowerScale = 0
	p.ppzUpdateFollowerScaleTime = 0
	p.ppzUpdateHorizScale = 0
	p.ppzUpdateHorizScaleTime = 0
	if not (p.mo and p.mo.valid) then return end
	p.ppzSpaceSpawn = {p.mo.x, p.mo.y, p.mo.z}
	p.follower_ref = nil
end)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) then return end
	if not (mo.target.player and mo.target.player.valid) then return end
	mo.target.player.follower_ref = mo
end, MT_FOLLOWER)

local cv_bighead = nil

local function K_Squish(mo, xadd, xtime)
	local maxstretch = 4*FRACUNIT
	local factor = 5 * mo.height / 4
	local threshold = factor / 6

	local old3dspeed = abs(mo.lastmomz)
	local new3dspeed = abs(mo.momz)

	local delta = abs(old3dspeed - new3dspeed)
	local grav = mo.height/3
	local add = abs(grav - new3dspeed)
	
	-- lmaoer
	local a = ease.linear(
		M_TimeFrac(xtime, TICRATE), 
		0, xadd
	)

	/* no need for this check, we only use this for the player anyway
	if (R_ThingIsFloorSprite(mo))
		return
	end
	*/

	if delta < 2 * add and new3dspeed > grav then
		delta = $ + add
	end

	if delta > threshold then
		mo.spritexscale = min(maxstretch, FRACUNIT + FixedDiv(delta, factor))

		if new3dspeed > old3dspeed or new3dspeed > grav then
			mo.spritexscale = FixedDiv(FRACUNIT, mo.spritexscale)
		end
	else
		mo.spritexscale = $ - (($ - FRACUNIT) / ($ < FRACUNIT and 8 or 3))
	end
	
	mo.spritexscale = $ + a
	mo.spriteyscale = FixedDiv(FRACUNIT, mo.spritexscale)
	mo.spriteyscale = $ + (a/2)

	/* sorry big head fans
	cv_bighead = $ or CV_FindVar("bighead")
	if cv_bighead and cv_bighead.value then
		mo.spriteyscale = $*2
	end
	*/
end

addHook("PostThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		-- gimmick time
		p.ppzGimmickTime = max(0, $-1)
		if p.ppzUpdateFollowerScale > 0 and (p.follower_ref and p.follower_ref.valid) then
			--print("PLEASE")
			p.follower_ref.scale = ease.linear(
				M_TimeFrac(p.ppzUpdateFollowerScaleTime, TICRATE),
				$, p.ppzUpdateFollowerScale
			)
			p.ppzUpdateFollowerScaleTime = min(TICRATE, $ + 1)
		end
	end
	
	--if g_chanceTime.desctime != -1 then
	g_chanceTime.desctime = max(0, $-1)
	if g_chanceTime.desctime == 0 then
		g_chanceTime.hud_active = g_chanceTime.active
		--print(g_chanceTime.hud_active)
	end
	--end
end)

addHook("MapLoad", function()
	for p in players.iterate do
		p.ppzCurrentLog = {}
		p.ppzShitCounter = 0
	end
end)

local function K_PlayerEBrake(player)
	if player.respawn.state then return false end
	if player.fastfall then return false end
	if ((player.cmd.buttons & (BT_DRIFT|BT_BRAKE)) != (BT_DRIFT|BT_BRAKE)) return false end
	if player.drift > 0 and P_IsObjectOnGround(player.mo) then return false end
	if P_PlayerInPain(player) then return false end
	if player.justbumped then return false end
	if player.spindashboost then return false end
	if player.nocontrol then return false end

	return true
end

-- Yeah
local BT_VOTE = (1<<7)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if p.spectator then return end
	if p.ppzUpdateHorizScale > 0 then
		K_Squish(p.mo, p.ppzUpdateHorizScale, p.ppzUpdateHorizScaleTime)
		p.ppzUpdateHorizScaleTime = min(TICRATE, $ + 1)
	end
	
	if g_chanceTime.interoggator != p then return end
	if not g_chanceTime.hud_active then return end
	
	-- handle this outside kms
	for i, h in ipairs(g_chanceTime.hud_trans) do
		if h < 0 then continue end
		--print("PLEASE")
		g_chanceTime.hud_trans[i] = $+1
	end
	
	-- handle chance time
	if not g_chanceTime.active then return end
	
	-- we are the interoggator
	-- we get... to choose.
	local mo = p.mo
	local cmd = p.cmd
	p.ppzLastCTState = $ or CHANCESTATE_NONE
	p.ppzCTRandomOffset = $ or 0
	
	local confirm = false
	if g_chanceTime.elapsed > TICRATE then
		if g_chanceTime.elapsed > TICRATE<<4 then
			confirm = true
		elseif ((p.bot or p.exiting) and g_chanceTime.elapsed > (TICRATE*3+p.ppzCTRandomOffset)) then
			confirm = true
		else
			-- wtf?
			confirm = (!(!(cmd.buttons & BT_ATTACK)))
		end
	end
	
	-- confimed? calculate selection and move on to next state
	if confirm then
		-- TODO: Add latency fudge
		if g_chanceTime.state == CHANCESTATE_PICKINGV1 then
			g_chanceTime.victim1 = g_chanceTime.victim1list[g_chanceTime.idx+1]
			for k, v in ipairs(ct_sets) do
				if (v[4]() == false) then continue end
				table.insert(
					g_chanceTime.sets, {
						rule = v[2],
						type = v[1],
						prefix = v[3],
					}
				)
			end
			g_chanceTime.curLen = #g_chanceTime.sets
			--print("picked victim1! "..g_chanceTime.victim1.name)
		elseif g_chanceTime.state == CHANCESTATE_PICKINGRULE then
			local set = g_chanceTime.sets[g_chanceTime.typeidx+1]
			g_chanceTime.rule = set.rule
			g_chanceTime.type = set.type
			g_chanceTime.rulegfx = string.format(set.prefix, set.rule)
			-- generate victim 2 listing
			for q in players.iterate do
				if q.spectator then continue end
				if not (q.mo and q.mo.valid) then continue end
				-- initiator not included (us)
				if q == p then continue end
				-- victim1 not included
				if q == g_chanceTime.victim1 then continue end
				table.insert(g_chanceTime.victim2list, q)
			end
			L_Shuffle(g_chanceTime.victim2list)
			g_chanceTime.curLen = #g_chanceTime.victim2list
			--print("picked rule! "..tostring(g_chanceTime.rule))
		elseif g_chanceTime.state == CHANCESTATE_PICKINGV2 then
			g_chanceTime.victim2 = g_chanceTime.victim2list[g_chanceTime.idx+1]
			local f, cond = unpack(chancetime_funcs[g_chanceTime.type])
			-- finally, run the function
			--print("ran type! "..tostring(g_chanceTime.type))
			g_chanceTime.desc = f(g_chanceTime.victim1, g_chanceTime.victim2, g_chanceTime.rule)
			g_chanceTime.desctime = TICRATE*3
			-- disable this now...
			g_chanceTime.active = false
			lookingforatag = ACS_ENABLECTS
		end
		g_chanceTime.idx = 0
		g_chanceTime.tics = 0
		g_chanceTime.typeidx = max(g_chanceTime.curLen-1, $)
		g_chanceTime.elapsed = 0
		--g_chanceTime.delay = TICRATE/2
		g_chanceTime.sound = 0
		g_chanceTime.state = $ + 1
		S_StartSound(nil, sfx_itrolf)
		g_chanceTime.hud_trans[g_chanceTime.state] = 1
	end
	
	if not g_chanceTime.active then return end
	
	-- handle roulette elapsed and tics
	g_chanceTime.elapsed = $ + 1
	--g_chanceTime.trueelapsed = $ + 1
	
	if g_chanceTime.tics == 0 then
		g_chanceTime.idx = ($ + 1) % g_chanceTime.curLen
		if g_chanceTime.state == CHANCESTATE_PICKINGRULE then
			g_chanceTime.typeidx = ($ + 1) % g_chanceTime.curLen
		end
		p.ppzCTRandomOffset = P_RandomRange(-TICRATE, TICRATE)
		g_chanceTime.tics = 3
		g_chanceTime.sound = ($ + 1) % 8
		S_StartSound(nil, sfx_itrol1 + g_chanceTime.sound)
	else
		g_chanceTime.tics = max(0, $ - 1)
	end
	
	p.ppzLastCTState = g_chanceTime.state
end)

addHook("MapChange", function()
	-- reset chance time variables
	g_chanceTime.active = false
	resetchancetime()
	g_chanceTime.typeidx = 0
	g_chanceTime.desctime = 0
	--g_chanceTime.spaces = {}
end)

WTXT.createNewFont({ -- not credits font
	name = "CRED",
	prefix = "LTFNT",
	spacewidth = 12,
})

WTXT.createNewFont({ -- thin font
	name = "TINY",
	prefix = "TNYFN",
	spacewidth = 2,
	dimfunc = function(scale, pcw)
		return FixedMul(pcw - (1<<FRACBITS), scale)
	end,
	fallbackColors = true
})

local function shitbox(v, x, y, func)
	v.drawScaled(
		x, y, FRACUNIT, v.cachePatch("K_SBBG"), V_SNAPTOTOP|V_SLIDEIN
	)
	if func then
		func(v, x, y)
	end
end

local function cthud(v, p, c)
	if not g_chanceTime.hud_active then return end
	
	local transOne = g_chanceTime.hud_trans[1] > 0 and ease.outsine(M_TimeFrac(g_chanceTime.hud_trans[1], TICRATE/2), -FRACUNIT/4, FRACUNIT) or 0
	local transTwo = g_chanceTime.hud_trans[2] > 0 and ease.inoutsine(M_TimeFrac(g_chanceTime.hud_trans[2], TICRATE/4)) or 0
	local transThree = g_chanceTime.hud_trans[3] > 0 and ease.inoutsine(M_TimeFrac(g_chanceTime.hud_trans[3], TICRATE/4)) or 0
	local transFour = g_chanceTime.hud_trans[1] > 0 and ease.inoutsine(M_TimeFrac(g_chanceTime.hud_trans[4], TICRATE/4)) or 0
	local shit = TICRATE - min(TICRATE, g_chanceTime.desctime)
	-- Why does the game not respect these checks.
	local frac = (shit > 0 and g_chanceTime.desctime > 0) and M_TimeFrac(shit, TICRATE) or 0
	local transFive = (g_chanceTime.desctime == 0) and 0 or ease.inoutsine(frac)
	
	local fx = (320/2)<<FRACBITS
	local fy = 22<<FRACBITS
	
	local barflags = V_SNAPTOTOP|V_SLIDEIN
	
	fy = $ - 96*transFive
	
	shitbox(v, 
		FixedMul(fx - (15<<FRACBITS) + (15*transTwo) + (15*transThree), transOne),
		fy, function(v, x, y)
			if g_chanceTime.state < 3 then return end
			local victim = g_chanceTime.state == 3 and g_chanceTime.victim2list[g_chanceTime.idx+1] or g_chanceTime.victim2
			local skin = victim.skin
			local skincolor = victim.skincolor
			local cmap = g_chanceTime.state == 3 and v.getColormap(TC_RAINBOW, SKINCOLOR_JAWZ) or v.getColormap(skin, skincolor)
			if g_chanceTime.hud_trans[4] < TICRATE/2 and (g_chanceTime.hud_trans[4] % 3) == 0 then
				cmap = v.getColormap(TC_ALLWHITE, skincolor)
			end
			local mmap = v.getSprite2Patch(skin, "XTRA", false, A, 0, 0)
			v.drawScaled(x+(7*FRACUNIT), y+(6*FRACUNIT), FRACUNIT, mmap, barflags, cmap)
		end
	)
	
	shitbox(v, 
		FixedMul(fx - (15<<FRACBITS) + (15*transTwo) - (15*transThree), transOne),
		fy, function(v, x, y)
			if g_chanceTime.state < 2 then return end
			local set = g_chanceTime.sets[g_chanceTime.typeidx+1]
			local gfx = g_chanceTime.state == 2 and string.format(set.prefix, set.rule) or g_chanceTime.rulegfx
			local cmap = g_chanceTime.state == 2 and v.getColormap(TC_RAINBOW, SKINCOLOR_JAWZ) or nil
			if g_chanceTime.hud_trans[3] < TICRATE/2 and (g_chanceTime.hud_trans[3] % 3) == 0 then
				cmap = v.getColormap(TC_ALLWHITE, skincolor)
			end
			v.drawScaled(x+(7*FRACUNIT), y+(6*FRACUNIT), FRACUNIT, v.cachePatch(gfx), barflags, cmap)
			if g_chanceTime.state < 4 then return end
		end
	)
	
	shitbox(v, 
		FixedMul(fx - (15<<FRACBITS) - (15*transTwo) - (15*transThree), transOne),
		fy, function(v, x, y)
			if g_chanceTime.state < 1 then return end
			local victim = g_chanceTime.state == 1 and g_chanceTime.victim1list[g_chanceTime.idx+1] or g_chanceTime.victim1
			local skin = victim.skin
			local skincolor = victim.skincolor
			local cmap = g_chanceTime.state == 1 and v.getColormap(TC_RAINBOW, SKINCOLOR_JAWZ) or v.getColormap(skin, skincolor)
			if g_chanceTime.hud_trans[2] < TICRATE/2 and (g_chanceTime.hud_trans[2] % 3) == 0 then
				cmap = v.getColormap(TC_ALLWHITE, skincolor)
			end
			local mmap = v.getSprite2Patch(skin, "XTRA", false, A, 0, 0)
			v.drawScaled(x+(7*FRACUNIT), y+(6*FRACUNIT), FRACUNIT, mmap, barflags, cmap)
		end
	)
	
	if g_chanceTime.desctime > 0 and g_chanceTime.desc ~= "" then
		WTXT.writeText(v, {
			x = 160<<FRACBITS, y = fy-(10<<FRACBITS),
			font = FONT_TINY,
			text = g_chanceTime.desc,
			halign = 0,
			dflags = barflags|V_20TRANS,
		})
	end
	
	if g_chanceTime.hud_trans[1] >= TICRATE and g_chanceTime.interoggator then
		local txt = "Blame: "..g_chanceTime.interoggator.name
		local trackx = fx-(6*FRACUNIT)
		if g_chanceTime.interoggator == p then
			txt = "Press ITEM to proceed..."
			trackx = fx
			if not g_chanceTime.active then return end
		end
		WTXT.writeText(v, {
			x = trackx, y = fy+(28*FRACUNIT),
			font = FONT_TINY,
			text = txt,
			halign = 0,
			dflags = barflags|V_20TRANS,
			predrawfunc = function(dd, b, l, pi)
				if g_chanceTime.interoggator == p then
					pi.yoff = v.RandomRange(-1, 1)*FRACUNIT
				end
				trackx = dd.x + b.x + l.x + pi.x + pi.xoff
			end
		})
		if g_chanceTime.interoggator != p then
			local skin = g_chanceTime.interoggator.skin
			local skincolor = g_chanceTime.interoggator.skincolor
			local cmap = v.getColormap(skin, skincolor)
			local mmap = v.getSprite2Patch(skin, "XTRA", false, C, 0, 0)
			v.drawScaled(trackx+(6*FRACUNIT), fy+(26*FRACUNIT), FRACUNIT, mmap, barflags|V_20TRANS, cmap)
		end
	end
end

-- coords lmao
local function drawTinyPingIcon(v, x, y, scale, idx, flags, cmap)
	local pch = v.cachePatch(string.format("PPTNY%d", idx))
	v.drawScaled(x, y, scale, pch, flags, cmap)
end

local fpscount = nil

local function pingoffs(p)
	local y = 188
	if (p.cmd.latency > 0 or netgame) and not replayplayback then
		y = $ - 18
	end
	fpscount = CV_FindVar("showfps") or nil
	if fpscount and fpscount.value then
		y = $ - 11
	end
	return y*FRACUNIT
end

local function hudhell(v, p, c)
	if not mapheaderinfo[gamemap].ppzcheck then return end
	WTXT.fontSentinel(v)
	if leveltime == 0 then return end
	--if splitscreen then return end
	if v.splitscreen and v.splitscreen() > 0 then return end
	
	-- truth
	if p.ppzGimmickTime > 0 then
		local wid = (M_TimeFrac(p.ppzGimmickTime, TICRATE*3) * 80)
		local w = FixedDiv(wid, 64*FRACUNIT)
		local fx = 160
		local fy = 12+17
		v.drawStretched((fx<<FRACBITS)-(wid/2), fy<<FRACBITS, w, FRACUNIT/64, v.cachePatch("~000"), V_SLIDEIN|V_SNAPTOTOP|V_SNAPTOLEFT)
	end
	
	local yoffs = 0
	local xoffs = 0
	
	-- current effects
	
	-- targetted by a boss
	if p.ppzShitCounter > 0 then
		local map = v.getColormap(0, ((leveltime/5) & 1) and SKINCOLOR_GREY or SKINCOLOR_BLACK)
		for i=p.ppzShitCounter, 1,-1 do
			if xoffs >= 30 then break end -- max of 3 logs at a time
			drawTinyPingIcon(v, 309*FRACUNIT-(xoffs*FRACUNIT), pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, 11, V_SNAPTOBOTTOM|V_SNAPTORIGHT, map)
			xoffs = $ + 10
		end
		yoffs = $ + 10
	end
	-- fat
	local cmap = v.getColormap(0, SKINCOLOR_BLACK)
	xoffs = 0
	if p.ppzUpdateHorizScale then
		drawTinyPingIcon(v, 309*FRACUNIT-(xoffs*FRACUNIT), pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, 9, V_SNAPTOBOTTOM|V_SNAPTORIGHT, cmap)
		xoffs = $+10
	end
	if p.ppzUpdateFollowerScale then
		drawTinyPingIcon(v, 309*FRACUNIT-(xoffs*FRACUNIT), pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, 10, V_SNAPTOBOTTOM|V_SNAPTORIGHT, cmap)
		xoffs = $+10
	end
	if p.ppzUpdateFollowerScale or p.ppzUpdateHorizScale then
		yoffs = $ + 10
	end
	xoffs = 0
	-- forced space?
	if g_miscStuff.fuckedSpace > 0 then
		drawTinyPingIcon(v, 309*FRACUNIT-(xoffs*FRACUNIT), pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, 4+g_miscStuff.fuckedSpace, V_SNAPTOBOTTOM|V_SNAPTORIGHT, cmap)
		xoffs = $+10
	end
	-- red shit
	if g_miscStuff.redspaceconfirmed > 0 then
		drawTinyPingIcon(v, 309*FRACUNIT-(xoffs*FRACUNIT), pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, 12, V_SNAPTOBOTTOM|V_SNAPTORIGHT, cmap)
		xoffs = $+10
	end
	if g_miscStuff.fuckedSpace or g_miscStuff.redspaceconfirmed then
		yoffs = $+10
	end
	xoffs = 0
	if yoffs > 0 then
		yoffs = $+2
		-- add a tiny separator
		local w = FixedDiv(9*FRACUNIT, 64*FRACUNIT)
		v.drawStretched(309*FRACUNIT, pingoffs(p)-(yoffs*FRACUNIT)+(FRACUNIT*10), w, (FRACUNIT/64), v.cachePatch("~031"), V_TRANSLUCENT)
	end
	
	-- draw log
	local logoffs = 0
	for i=#p.ppzCurrentLog,1,-1 do
		if logoffs >= 4 then break end -- max of 4 logs at a time
		local val = p.ppzCurrentLog[i]
		drawTinyPingIcon(v, 309*FRACUNIT, pingoffs(p)-(yoffs*FRACUNIT), FRACUNIT, val, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		yoffs = $ + 10
		logoffs = $+1
	end
	
	-- title
	if p.ppzGimmickTime > 0 and ((p.ppzGimmickTime % 4 < 2) or p.ppzGimmickTime <= TICRATE*3-TICRATE/2) then
		WTXT.writeText(v, {
			x = 160<<FRACBITS, y = 12<<FRACBITS,
			font = FONT_CRED,
			text = hudttl[p.ppzLastSpace],
			halign = 0,
			dflags = V_SLIDEIN|V_SNAPTOTOP|V_20TRANS,
		})
		WTXT.writeText(v, {
			x = 160<<FRACBITS, y = 32<<FRACBITS,
			font = FONT_TINY,
			text = p.ppzEventName,
			halign = 0,
			dflags = V_SLIDEIN|V_SNAPTOTOP|V_20TRANS,
		})
	end
	
	-- chance time ahhaa
	cthud(v, p, c)
end

hud.add(hudhell, "game")