-- ZDialogue
-- A shitty solution to a problem that never existed
--
-- Meant to be used in tandem with ACS - not for exclusive Lua use!

freeslot("sfx_erzdng")

local ZDIALOGUE_VERSION = 1
local LOADED_VERSION = rawget(_G, "ZDIALOGUE")

-- Look, no need to load all this again when we don't need to.
if LOADED_VERSION != nil then
	if ZDIALOGUE_VERSION <= LOADED_VERSION then return end
end

freeslot("MT_ZDIALOGUETHINKER")

-- Global dialogue thinker- required for ACS to properly work
mobjinfo[MT_ZDIALOGUETHINKER] = {
	doomednum = 29566,
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP,
}

-- erazor font, seen in text boxes
-- has a dropshadow
WTXT.createNewFont({ 
	name = "ERZ",
	prefix = "ERZFN",
	monowidth = 8,
	spacewidth = 8,
	forceUppercase = true,
})

-- erazor font, seen in text boxes, now with an outline!
-- usually the "bold" font
WTXT.createNewFont({ 
	name = "ERZBOLD",
	prefix = "ERZF2",
	monowidth = 8,
	spacewidth = 8,
	forceUppercase = true,
})

-- Best practice lmao
-- Value determines what type to check
local availableIndexes = {
	-- If the current text box is active or not
	["active"] = "boolean",
	-- Slide amount.
	["slide"] = "number",
	-- Current line of text
	["line"] = "string",
	-- Text destination
	["dest"] = "string",
	-- Text progress time
	["progTime"] = "number",
	-- Text progress speed
	["progSpeed"] = "number",
	-- Text is currently done and can proceed
	["textDone"] = "boolean",
	-- text is dismissable
	["dismissable"] = "boolean",
	-- delay end to account for acs lmao
	["inactive_nf"] = "number",
	-- CHOICES --
-- 	-- A choice box is active
-- 	["choiceActive"] = "boolean",
-- 	-- List of choices. Contains a table of a string and a number for:
-- 	-- 1 - choice name, 2 - ball switch tag callback
-- 	["choices"] = "table",
-- 	-- Number of choices
-- 	["choicesLen"] = "number",
-- 	-- Current choice index
-- 	["choiceIndex"] = "number",
	-- VISUAL SHIT --
	-- Text sound
	["voice"] = "number",
	-- Use syllables? 
	["useSyllables"] = "boolean",
	-- Current syllable status
	["syllable"] = "boolean",
-- 	-- Choice Selection
-- 	["choiceVoice"] = "number",
-- 	-- Choice Confirm
-- 	["choiceConfirm"] = "number",
	-- Portrait
	["portrait"] = "string",
	-- Name
	["name"] = "string",
	-- style
	["style"] = "number",
}

-- Shitty metatable
local zdialogue_t = {
	__index = function(zd, key)
		if availableIndexes[key] or key == "origin" then
			return rawget(zd, key)
		end
	end,
	__newindex = function(zd, key, value)
		-- Simply setting availableIndexes[key] to not be a value 
		-- that can be returned by type() is enough to make it uneditable lol
		if (availableIndexes[key] and type(value) == availableIndexes[key]) or key == "origin" then
			return rawset(zd, key, value)
		end
	end,
}

local function ZD_ClearText(self)
	self.line = ""
	self.dest = ""
end

local function ZD_NewText(self, text)
	text = WTXT.replaceTags($)
	text = WTXT.wordWrap($, FONT_ERZ, (10*8), FRACUNIT, 0, DF_MONOSPACE)
	self.line = ""
	
	self.dest = text
	self.dest = string.reverse($)
	
	self.progTime = TICRATE/5
	self.progSpeed = 1
	self.textDone = false
	self.choiceActive = false
	self.active = true
end

local function ispunct(s)
	local b = s:byte(1,1)
	if b >= 33 and b <= 47 then return true end
	if b >= 58 and b <= 64 then return true end
	if b >= 91 and b <= 96 then return true end
	if b >= 123 and b <= 126 then return true end
end

local function ZD_WriteText(self)
	if self.textDone then return end
	
	local voicePlayed = false
	local empty = self.dest == ""
	local lastc = " "
	
	self.progTime = $ - self.progSpeed
	
	while (self.progTime <= 0 and empty == false) do
		local c = self.dest:sub(-1)
		local nextc = "\n"
		local b = string.byte(c,1,1)
		
		self.line = $..c
		self.dest = self.dest:sub(1, -2)
		empty = self.dest == ""
		
		-- Control codes, skip
		if b > 127 or b < 32 then
			-- <wait> tag
			if b == 0xC1 then
				self.progTime = $ + TICRATE*2/5
			end
			lastc = c
			continue
		end
		
		-- Spaces everywhere
		if ((lastc == " " or lastc == "\n") and c == " ") then
			lastc = c
			continue
		end
		
		if (empty == false) then
			nextc = self.dest:sub(-1)
		end
		
		if (voicePlayed == false and c != " " and c != "\n") then
			if self.syllable and self.useSyllables and self.voice then
				local og = nil
				if self.origin and self.origin.player then og = self.origin end
				S_StopSoundByID(og, self.voice)
				S_StartSound(og, self.voice)
			end
			if not self.useSyllables then
				local og = nil
				if self.origin and self.origin.player then og = self.origin end
				S_StartSound(og, self.voice)
			end
			self.syllable = not $
			voicePlayed = true
		end
		
		if (c != "+" and b != 34
			and ispunct(c) and nextc == " ") then
			self.progTime = $ + TICRATE*2/5
		end
		self.progTime = $ + self.progSpeed
		
		lastc = c
	end
	
	self.textDone = (self.progTime <= 0 and empty)
end

local function ZD_CompleteText(self)
	while (self.dest != "") do
		local c = self.dest:sub(-1)
		self.line = $..c
		self.dest = self.dest:sub(1, -2)
	end
	self.progTime = 0
	self.textDone = true
end

local function ZD_SetSpeakerName(self, name)
	name = WTXT.replaceTags($)
	self.name = name
end

local function ZD_SetSpeakerVoice(self, voice, syllable)
	self.voice = _G["sfx_"..voice]
	self.useSyllables = syllable > 0
end

local function ZD_SetSpeakerPortrait(self, name)
	self.portrait = name
end

local BT_VOTE = (1<<7)

local function ZD_Pressed(self)
	local p = server
	if self.origin and self.origin.player then p = self.origin.player end
	return (
		((p.cmd.buttons & BT_VOTE) == BT_VOTE) and
		((p.oldcmd.buttons & BT_VOTE) == 0)
	)
end

local function ZD_Held(self)
	local p = server
	if self.origin and self.origin.player then p = self.origin.player end
	return ((p.cmd.buttons & BT_VOTE) == BT_VOTE)
end

local slidespeed = FRACUNIT / (TICRATE/2)

local function ZD_Tick(self)
	if self.inactive_nf then
		self.inactive_nf = $-1
		if self.inactive_nf <= 0 then
			self.active = false
			ZD_ClearText(self)
		end
	end
	
	if self.active then
		if self.slide < FRACUNIT then
			self.slide = $+slidespeed
		end
	else
		if self.slide > 0 then
			self.slide = $-slidespeed
			if self.slide < 0 then
				self.active = false
			end
		end
	end
	
	self.slide = max(0, min(FRACUNIT, $))
	
	-- Origin handler...
	if self.origin and self.origin.valid then
		local mo = self.origin
		-- player death kill the box
		if mo.player and mo.health <= 0 then
			self.active = false
			ZD_ClearText(self)
		end
		-- cvmem determines if its active
		mo.movecount = self.active and 1 or 0
		-- check for inactive_nf lmao
		if self.inactive_nf then mo.movecount = 0 end
		-- cusval determines if the text is complete
		mo.movedir = self.textDone and 1 or 0
	end
	
	if self.slide != FRACUNIT then return end
	
	ZD_WriteText(self)
	
	if self.origin and self.origin.valid then
		local mo = self.origin
		mo.movedir = self.textDone and 1 or 0
		--print(mo.cusval)
	end
	
	if self.dismissable and ZD_Pressed(self) then
		if self.textDone then
			self.inactive_nf = 2
			--ZD_ClearText(self)
		else
			ZD_CompleteText(self)
		end
	end
end

local function ZD_Draw(self, v, p, c)
	if self.slide == 0 then return end
	
	-- fonter
	WTXT.fontSentinel(v)
	
	--print("omg hiii")
	
	-- default style: erazor
	if self.style == 0 then
		local slLeftMul = self.slide and ease.outsine(self.slide, -320<<FRACBITS, 0) or -320*FRACUNIT
		local slRightMul = self.slide and ease.outsine(self.slide, 320<<FRACBITS, 0) or 320*FRACUNIT
		local slideOffs = self.active and slLeftMul or slRightMul
		if self.slide == FRACUNIT then slideOffs = 0 end
		
		local charWidth = (20*8)<<FRACBITS
		local boxHeight = (8*8)<<FRACBITS
		local scrCenterX = ((320/2)<<FRACBITS)+slideOffs
		local scrCenterY = (200/2)<<FRACBITS
		
		-- bg
		v.drawScaled(
			scrCenterX - (176/2)<<FRACBITS,
			scrCenterY - (80/2)<<FRACBITS,
			FRACUNIT,
			v.cachePatch("ZDERZBOX"), 0
		)
		
		-- text itself
		if self.name != "" then
			v.drawStretched(
				scrCenterX - (charWidth / 2), scrCenterY - (boxHeight / 2) - (12<<FRACBITS),
				FixedDiv(string.len(self.name)*(8*FRACUNIT), 64*FRACUNIT),
				FixedDiv(8*FRACUNIT, 64*FRACUNIT),
				v.cachePatch("~026"), 0
			)
			WTXT.writeText(v, {
				x = scrCenterX - (charWidth / 2), y = scrCenterY - (boxHeight / 2) - (12<<FRACBITS),
				font = FONT_ERZ,
				boldFont = FONT_ERZBOLD,
				text = self.name,
				halign = -FRACUNIT,
				width = charWidth,
				predrawfunc = function(dd, b, l, pi)
					if pi.bold and ((leveltime/8) & 1) then
						pi.colormap = v.getColormap(TC_BOSS, SKINCOLOR_WHITE)
					end
				end
			})
		end
		if self.line == "" then return end
		--local text = BreakUpText(v, self.line, charWidth/FRACUNIT)
		WTXT.writeText(v, {
			x = scrCenterX - (charWidth / 2), y = scrCenterY - (boxHeight / 2),
			font = FONT_ERZ,
			boldFont = FONT_ERZBOLD,
			text = self.line,
			halign = -FRACUNIT,
			width = charWidth,
			predrawfunc = function(dd, b, l, pi)
				if pi.bold and ((leveltime/8) & 1) then
					pi.colormap = v.getColormap(TC_BOSS, SKINCOLOR_WHITE)
				end
			end
		})
	end
end

local function ZD_New()
	local zd = {}
	zd.active = false
	zd.slide = 0
	zd.line = ""
	zd.dest = ""
	zd.progTime = 0
	zd.progSpeed = 1
	zd.textDone = false
	zd.dismissable = true
	zd.voice = sfx_None
	zd.useSyllables = true
	zd.syllable = false
	zd.portrait = ""
	zd.name = ""
	zd.style = 0
	/*
	zd.newText = ZD_NewText
	zd.writeText = ZD_WriteText
	zd.clearText = ZD_ClearText
	zd.completeText = ZD_CompleteText
	zd.setSpeaker = function(zd, name, portrait, voice, syllable)
		ZD_SetSpeakerName(zd, name)
		ZD_SetSpeakerVoice(zd, voice, syllable)
		ZD_SetSpeakerPortrait(zd, portrait)
	end
	zd.update = ZD_Tick
	zd.draw = ZD_Draw
	*/
	setmetatable(zd, zdialogue_t)
	return zd
end

-- Global dialogue
rawset(_G, "g_zDialogue", ZD_New())

local function hook_findGlobalHandler(mo, mt)
	-- fuck it
	g_zDialogue.origin = mo
end

local function hook_updateGlobal()
	ZD_Tick(g_zDialogue)
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		if p.zDialogue then
			ZD_Tick(p.zDialogue)
		end
	end
end

local function hook_drawGlobal(v, p, c)
	ZD_Draw(g_zDialogue, v, p, c)
	if p.spectator then return end
	if p.zDialogue then
		ZD_Draw(p.zDialogue, v, p, c)
	end
end

local function hook_playerSpawn(p)
	p.zDialogue = ZD_New()
	p.zDialogue.origin = p.mo
end

local hookActivators = {
	["ZD_NEWTEXT"] = function(a, args, stringargs)
		local zd = g_zDialogue
		if (a and a.mo and a.mo.player) then
			zd = a.mo.player.zDialogue
		end
		if not stringargs[1] then
			print("ZDIALOGUE_NEWTEXT: You stupid.")
		end
		--print(stringargs[1])
		ZD_NewText(zd, stringargs[1])
		zd.origin.movecount = 1
		zd.inactive_nf = 0
	end,
	["ZD_AUTODISMISS"] = function(a, args, stringargs)
		local zd = g_zDialogue
		if (a and a.mo and a.mo.player) then
			zd = a.mo.player.zDialogue
		end
		zd.active = false
		ZD_ClearText(zd)
	end,
	["ZD_SPEAKERNAME"] = function(a, args, stringargs)
		local zd = g_zDialogue
		if (a and a.mo and a.mo.player) then
			zd = a.mo.player.zDialogue
		end
		if not stringargs[1] then
			print("ZDIALOGUE_SETSPEAKERNAME: You stupid.")
		end
		--print(stringargs[1])
		ZD_SetSpeakerName(zd, stringargs[1])
	end,
	["ZD_SPEAKERVOICE"] = function(a, args, stringargs)
		local zd = g_zDialogue
		if (a and a.mo and a.mo.player) then
			zd = a.mo.player.zDialogue
		end
		if not stringargs[1] then
			print("ZDIALOGUE_SETSPEAKERVOICE: You stupid.")
		end
		--print(stringargs[1])
		ZD_SetSpeakerVoice(zd, stringargs[1], args[2] or 0)
	end,
	["ZD_SPEAKERPORTRAIT"] = function(a, args, stringargs)
		local zd = g_zDialogue
		if (a and a.mo and a.mo.player) then
			zd = a.mo.player.zDialogue
		end
		if not stringargs[1] then
			print("ZDIALOGUE_SETSPEAKERPORTRAIT: You stupid.")
		end
		zd.active = false
		ZD_SetSpeakerPortrait(zd, stringargs[1])
	end,
}

local function hook_netvars(net)
	g_zDialogue = net($)
end

if not ZDIALOGUE_HOOKS then
	rawset(_G, "ZDIALOGUE_HOOKS", {})
	ZDIALOGUE_HOOKS.ThinkFrame = hook_updateGlobal
	ZDIALOGUE_HOOKS.hudDraw = hook_drawGlobal
	ZDIALOGUE_HOOKS.acsDummy = hook_findGlobalHandler
	ZDIALOGUE_HOOKS.SpecialExecutes = hookActivators
	ZDIALOGUE_HOOKS.PlayerSpawn = hook_playerSpawn
	ZDIALOGUE_HOOKS.NetVars = hook_netvars
	addHook("ThinkFrame", ZDIALOGUE_HOOKS.ThinkFrame)
	addHook("MapThingSpawn", ZDIALOGUE_HOOKS.acsDummy, MT_ZDIALOGUETHINKER)
	addHook("SpecialExecute", hookActivators["ZD_NEWTEXT"], "ZD_NEWTEXT")
	addHook("SpecialExecute", hookActivators["ZD_AUTODISMISS"], "ZD_AUTODISMISS")
	addHook("SpecialExecute", hookActivators["ZD_SPEAKERNAME"], "ZD_SPEAKERNAME")
	addHook("SpecialExecute", hookActivators["ZD_SPEAKERVOICE"], "ZD_SPEAKERVOICE")
	addHook("SpecialExecute", hookActivators["ZD_SPEAKERPORTRAIT"], "ZD_SPEAKERPORTRAIT")
	addHook("PlayerSpawn", ZDIALOGUE_HOOKS.PlayerSpawn)
	addHook("NetVars", ZDIALOGUE_HOOKS.NetVars)
	hud.add(ZDIALOGUE_HOOKS.hudDraw, "game")
	print("Loading ZDialogue for the first time... initializing hooks...")
else
	ZDIALOGUE_HOOKS.ThinkFrame = hook_updateGlobal
	ZDIALOGUE_HOOKS.hudDraw = hook_drawGlobal
	ZDIALOGUE_HOOKS.acsDummy = hook_findGlobalHandler
	ZDIALOGUE_HOOKS.SpecialExecutes = hookActivators
	ZDIALOGUE_HOOKS.PlayerSpawn = hook_playerSpawn
	ZDIALOGUE_HOOKS.NetVars = hook_netvars
	print("Loading ZDialogue... replacing hooks...")
end

-- Always set this last!!!!
print("\x85".."ZDialogue has now been loaded! \x80"..string.format("(v%d)", ZDIALOGUE_VERSION))
rawset(_G, "ZDIALOGUE", ZDIALOGUE_VERSION)